import random
import re

# list of words generated by Chat GPT
WORDS = [
    # Cognitive Science
    "Cognition", "Perception", "Attention", "Memory", "Learning", 
    "Intelligence", "Problemsolving", "Consciousness", "Decisionmaking",
    "Language processing", "Neurology", "Psychology", "Neuroscience", 
    "Cognitive psychology", "Computational modeling",
    
    # AI (Artificial Intelligence)
    "Machine Learning", "Neural Networks", "Deep Learning", "Natural Language Processing",
    "Computer Vision", "Robotics", "Expert Systems", "Reinforcement Learning",
    "Genetic Algorithms", "Fuzzy Logic", "Swarm Intelligence", "Knowledge Representation",
    "Automated Reasoning", "Speech Recognition", "Planning and Scheduling",
    
    # Web Design
    "User Interface", "User Experience", "Responsive Design", "Information Architecture",
    "Interaction Design", "Visual Design", "Wireframing", "Prototyping", "Typography",
    "Color Theory", "Accessibility", "Mobile Optimization", "Web Standards", "Frontend Development"
]

HANGMANPICS = [
"\n\n\n\n\n\n\n=========",
"\n\n\n\n\n\t|\n=========",
"\n\n\n\n\n\t|\n\t|\n=========",
"\n\n\n\n\t|\n\t|\n\t|\n=========",
"\n\n\t|\n\t|\n\t|\n\t|\n=========", 
"\n\t|\n\t|\n\t|\n\t|\n\t|\n=========",
"\t+\n\t|\n\t|\n\t|\n\t|\n\t|\n=========",
"  ------+\n\t|\n\t|\n\t|\n\t|\n\t|\n=========",
" +------+\n\t|\n\t|\n\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n\t|\n\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n |\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n/|\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n/|\\\t|\n\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n/|\\\t|\n/\t|\n\t|\n=========",
" +------+\n |\t|\n O\t|\n/|\\\t|\n/ \\\t|\n\t|\n========="]

class Hangman_bot():

    def __init__(self):
        self.false_guesses = len(HANGMANPICS)
        self.playing = False
    
    def make_guess(self, guess):
        words_pattern = '[a-z]+'
        guess = re.findall(words_pattern, guess, flags=re.IGNORECASE)

        # if this is the first game or it was game over interpret this guess as a response to the initial question
        if self.playing == False:
            return self.new_game(guess)

        print("Your guess:", guess)

        # guessing the entire word
        if len(guess) == len(self.word) and len(guess[0]) > 1:
            for i in range(len(guess)):
                if guess[i] != self.word[i].lower():
                    print("false")
                    return self.wrong_guess()
            self.correct_guesses = self.word
            return self.right_guess()

        # guessing one letter
        elif len(guess) == 1 and len(guess[0]) == 1:
            rep = False
            for i in range(len(self.word)):
                for j in range(len(self.word[i])):
                    if self.word[i][j].lower() == guess[0].lower():
                        rep = True
                        self.correct_guesses[i] = self.correct_guesses[i][:j] + self.word[i][j] + self.correct_guesses[i][j+1:]
            if rep:
                return self.right_guess()
       
        return self.wrong_guess()
            
    def right_guess(self):
        output = ""
        for i in range(len(self.word)):
                output += " ".join(self.correct_guesses[i])
                output += "\n"
        return output 
    
    def wrong_guess(self):
        self.false_guesses += 1
        print(HANGMANPICS[self.false_guesses])
        output = HANGMANPICS[self.false_guesses]
        if self.false_guesses >= len(HANGMANPICS):
            print("GAME OVER")
            output += "\nGAME OVER\nThe correct phrase was: "
            for i in self.word:
                output += i
                output += "\n"
            return output
        else:
            output += "\n"
            for i in range(len(self.word)):
                    output += " ".join(self.correct_guesses[i])
                    output += "\n"
            return output 

    def new_game(self, message):
        if message[0].lower() == "yes":
            self.playing = True
            self.word = random.choice(WORDS)
            self.word = self.word.split(" ")
            self.correct_guesses = []
            self.false_guesses = 0
            print(self.word)
            length = []
            output = "Fantastic! Let me think of a word ... \nOk, got it! You can start typing your guesses into the channel. \nYou can either guess singular letters of try and guess the whole phrase. \nLet the guessing begin :)\n"
            for i in range(len(self.word)):
                length.append(len(self.word[i]))
                self.correct_guesses.append(length[i]*"_")
                output += " ".join(self.correct_guesses[i])
                output += "\n"
                print(length[i]*"_ ")
            return output
        else:
            self.playing = False
            return "Ok, maybe another time"
    
    def check_gamestatus(self):
        return self.playing
        
    